let : = macro {
  rule infix { $lhs:expr | : $rhs:expr } => {
    $lhs.prototype.$rhs
  }
  rule { } => { : }
}

let match = macro {
  rule infix { $lhs:expr | { $cases ... } } => {
    function{ $cases ... }($lhs)
  }
  rule { } => { match }
}

data List {
  Nil,
  Cons {
    head: *,
    tail: List
  }
}

List::map = λ fn -> this match {
  case Nil => Nil
  case Cons(x, xs) => Cons(fn(x), xs.map(fn))
};

List::reduce = λ(fn, acc) -> this match {
  case Nil => acc
  case Cons(x, xs) => xs.reduce(fn, fn(x, acc))
};

List::toArray = λ -> this.reduce(λ(acc, x) -> (acc.push(x), acc), []);
